---
title: DOMRect
slug: Web/API/DOMRect
tags:
  - API
  - DOM
  - DOM Reference
  - DOMRect
  - Geometry
  - Geometry Interfaces
  - Interface
  - Rectangle
  - Reference
---
<p>{{draft}}{{APIRef("Geometry Interfaces")}}</p>

<p>A <strong><code>DOMRect</code></strong> describes the size and position of a rectangle.</p>

<p>The type of box represented by the <code>DOMRect</code> is specified by the method or property that returned it. For example, {{domxref("VREyeParameters.renderRect")}} from the WebVR API specifies the viewport of a <a href="/en-US/docs/Web/API/HTMLCanvasElement">canvas</a> into which visuals for one eye of a head mounted display should be rendered.</p>

<p>It inherits from its parent, {{domxref("DOMRectReadOnly")}}.</p>

<p>{{InheritanceDiagram}}</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("DOMRect.DOMRect","DOMRect()")}}</dt>
 <dd>Creates a new <code>DOMRect</code> object.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em><code>DOMRect</code> inherits properties from its parent, {{domxref("DOMRectReadOnly")}}. The difference is that they are not read-only anymore.</em></p>

<dl>
 <dt>{{domxref("DOMRectReadOnly.x")}}</dt>
 <dd>The x coordinate of the <code>DOMRect</code>'s origin (typically the top-left corner of the rectangle).</dd>
 <dt>{{domxref("DOMRectReadOnly.y")}}</dt>
 <dd>The y coordinate of the <code>DOMRect</code>'s origin (typically the top-left corner of the rectangle).</dd>
 <dt>{{domxref("DOMRectReadOnly.width")}}</dt>
 <dd>The width of the <code>DOMRect</code>.</dd>
 <dt>{{domxref("DOMRectReadOnly.height")}}</dt>
 <dd>The height of the <code>DOMRect</code>.</dd>
 <dt>{{domxref("DOMRectReadOnly.top")}}</dt>
 <dd>Returns the top coordinate value of the <code>DOMRect</code> (has the same value as <code>y</code>, or <code>y + height</code> if <code>height</code> is negative.)</dd>
 <dt>{{domxref("DOMRectReadOnly.right")}}</dt>
 <dd>Returns the right coordinate value of the <code>DOMRect</code> (has the same value as <code>x + width</code>, or <code>x</code> if <code>width</code> is negative.)</dd>
 <dt>{{domxref("DOMRectReadOnly.bottom")}}</dt>
 <dd>Returns the bottom coordinate value of the <code>DOMRect</code> (has the same value as <code>y + height</code>, or <code>y</code> if <code>height</code> is negative.)</dd>
 <dt>{{domxref("DOMRectReadOnly.left")}}</dt>
 <dd>Returns the left coordinate value of the <code>DOMRect</code> (has the same value as <code>x</code>, or <code>x + width</code> if <code>width</code> is negative.)</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em><code>DOMRect</code> inherits methods from its parent, {{domxref("DOMRectReadOnly")}}.</em></p>

<dl>
 <dt>
 <h2 id="Static_methods">Static methods</h2>
 </dt>
 <dt>{{domxref("DOMRectReadOnly.fromRect()")}}</dt>
 <dd>Creates a new <code>DOMRect</code> object with a given location and dimensions.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Geometry Interfaces', '#DOMRect', 'DOMRect')}}</td>
   <td>{{Spec2('Geometry Interfaces')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DOMRect")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("DOMPoint")}}</li>
</ul>
